daemon-util.in 7.86 KB
Newer Older
1 2 3
#!/bin/bash
#

Michael Hanselmann's avatar
Michael Hanselmann committed
4
# Copyright (C) 2009, 2011, 2012 Google Inc.
5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.

set -e

23 24 25
@SHELL_ENV_INIT@

readonly defaults_file="$SYSCONFDIR/default/ganeti"
26

27 28 29 30
# This is a list of all daemons and the order in which they're started. The
# order is important as there are dependencies between them. On shutdown,
# they're stopped in reverse order.
DAEMONS=(
Petr Pudlak's avatar
Petr Pudlak committed
31
  ganeti-wconfd
32 33
  ganeti-noded
  ganeti-masterd
34
  ganeti-metad
35
  ganeti-rapi
36
  ganeti-luxid
37 38
  )

39 40 41 42 43
_confd_enabled() {
  [[ "@CUSTOM_ENABLE_CONFD@" == True ]]
}

if _confd_enabled; then
Iustin Pop's avatar
Iustin Pop committed
44 45 46
  DAEMONS+=( ganeti-confd )
fi

47 48 49 50 51 52 53 54
_mond_enabled() {
  [[ "@CUSTOM_ENABLE_MOND@" == True ]]
}

if _mond_enabled; then
  DAEMONS+=( ganeti-mond )
fi

55 56 57
NODED_ARGS=
MASTERD_ARGS=
CONFD_ARGS=
Petr Pudlak's avatar
Petr Pudlak committed
58
WCONFD_ARGS=
Thomas Thrainer's avatar
Thomas Thrainer committed
59
LUXID_ARGS=
60
RAPI_ARGS=
61
MOND_ARGS=
62 63 64 65 66 67

# Read defaults file if it exists
if [[ -s $defaults_file ]]; then
  . $defaults_file
fi

68 69 70 71 72 73
# Meant to facilitate use utilities in /etc/rc.d/init.d/functions in case
# start-stop-daemon is not available.
_ignore_error() {
  eval "$@" || :
}

74
_daemon_pidfile() {
75
  echo "$RUN_DIR/$1.pid"
76 77
}

78 79 80 81
_daemon_executable() {
  echo "@PREFIX@/sbin/$1"
}

82 83 84 85 86 87
_daemon_usergroup() {
  case "$1" in
    masterd)
      echo "@GNTMASTERUSER@:@GNTMASTERDGROUP@"
      ;;
    confd)
88
      echo "@GNTCONFDUSER@:@GNTCONFDGROUP@"
89
      ;;
Petr Pudlak's avatar
Petr Pudlak committed
90 91 92
    wconfd)
      echo "@GNTWCONFDUSER@:@GNTWCONFDGROUP@"
      ;;
Thomas Thrainer's avatar
Thomas Thrainer committed
93 94
    luxid)
      echo "@GNTLUXIDUSER@:@GNTLUXIDGROUP@"
95
      ;;
96 97 98 99
    rapi)
      echo "@GNTRAPIUSER@:@GNTRAPIGROUP@"
      ;;
    noded)
Michele Tartara's avatar
Michele Tartara committed
100
      echo "@GNTNODEDUSER@:@GNTNODEDGROUP@"
101
      ;;
102 103 104
    mond)
      echo "@GNTMONDUSER@:@GNTMONDGROUP@"
      ;;
105 106 107 108 109 110
    *)
      echo "root:@GNTDAEMONSGROUP@"
      ;;
  esac
}

111 112
# Checks whether the local machine is part of a cluster
check_config() {
113
  local server_pem=$DATA_DIR/server.pem
114 115 116 117 118 119 120 121 122 123 124 125
  local fname

  for fname in $server_pem; do
    if [[ ! -f $fname ]]; then
      echo "Missing configuration file $fname" >&2
      return 1
    fi
  done

  return 0
}

126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148
# Checks the exit code of a daemon
check_exitcode() {
  if [[ "$#" -lt 1 ]]; then
    echo 'Missing exit code.' >&2
    return 1
  fi

  local rc="$1"; shift

  case "$rc" in
    0) ;;
    11)
      echo "not master"
    ;;
    *)
      echo "exit code $rc"
      return 1
    ;;
  esac

  return 0
}

149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172
# Prints path to PID file for a daemon.
daemon_pidfile() {
  if [[ "$#" -lt 1 ]]; then
    echo 'Missing daemon name.' >&2
    return 1
  fi

  local name="$1"; shift

  _daemon_pidfile $name
}

# Prints path to daemon executable.
daemon_executable() {
  if [[ "$#" -lt 1 ]]; then
    echo 'Missing daemon name.' >&2
    return 1
  fi

  local name="$1"; shift

  _daemon_executable $name
}

173 174 175 176 177
# Prints a list of all daemons in the order in which they should be started
list_start_daemons() {
  local name

  for name in "${DAEMONS[@]}"; do
178 179 180
    if [[ "$name" != ganeti-metad ]]; then
      echo "$name"
    fi
181 182 183 184 185
  done
}

# Prints a list of all daemons in the order in which they should be stopped
list_stop_daemons() {
186 187 188
  for name in "${DAEMONS[@]}"; do
    echo "$name"
  done | tac
189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209
}

# Checks whether a daemon name is known
is_daemon_name() {
  if [[ "$#" -lt 1 ]]; then
    echo 'Missing daemon name.' >&2
    return 1
  fi

  local name="$1"; shift

  for i in "${DAEMONS[@]}"; do
    if [[ "$i" == "$name" ]]; then
      return 0
    fi
  done

  echo "Unknown daemon name '$name'" >&2
  return 1
}

210 211 212 213
# Checks whether daemon is running
check() {
  if [[ "$#" -lt 1 ]]; then
    echo 'Missing daemon name.' >&2
214
    return 1
215 216 217
  fi

  local name="$1"; shift
218 219 220 221 222 223 224 225 226 227 228
  local pidfile=$(_daemon_pidfile $name)
  local daemonexec=$(_daemon_executable $name)

  if type -p start-stop-daemon >/dev/null; then
    start-stop-daemon --stop --signal 0 --quiet \
      --pidfile $pidfile
  else
    _ignore_error status \
      -p $pidfile \
      $daemonexec
  fi
229 230 231 232 233 234
}

# Starts a daemon
start() {
  if [[ "$#" -lt 1 ]]; then
    echo 'Missing daemon name.' >&2
235
    return 1
236 237 238
  fi

  local name="$1"; shift
239 240 241
  # Convert daemon name to uppercase after removing "ganeti-" prefix
  local plain_name=${name#ganeti-}
  local ucname=$(tr a-z A-Z <<<$plain_name)
242 243 244
  local pidfile=$(_daemon_pidfile $name)
  local usergroup=$(_daemon_usergroup $plain_name)
  local daemonexec=$(_daemon_executable $name)
245

246
  if [[ "$name" == ganeti-confd ]] \
247
      && ! _confd_enabled; then
Iustin Pop's avatar
Iustin Pop committed
248 249 250 251
    echo 'ganeti-confd disabled at build time' >&2
    return 1
  fi

252
  # Read $<daemon>_ARGS and $EXTRA_<daemon>_ARGS
253
  eval local args="\"\$${ucname}_ARGS \$EXTRA_${ucname}_ARGS\""
254

255 256
  @PKGLIBDIR@/ensure-dirs

257 258 259 260 261 262 263 264 265 266 267 268 269 270
  if type -p start-stop-daemon >/dev/null; then
    start-stop-daemon --start --quiet --oknodo \
      --pidfile $pidfile \
      --startas $daemonexec \
      --chuid $usergroup \
      -- $args "$@"
  else
    # TODO: Find a way to start daemon with a group, until then the group must
    # be removed
    _ignore_error daemon \
      --pidfile $pidfile \
      --user ${usergroup%:*} \
      $daemonexec $args "$@"
  fi
271

272 273 274 275 276 277
}

# Stops a daemon
stop() {
  if [[ "$#" -lt 1 ]]; then
    echo 'Missing daemon name.' >&2
278
    return 1
279 280 281
  fi

  local name="$1"; shift
282
  local pidfile=$(_daemon_pidfile $name)
283

284 285 286 287 288 289
  if type -p start-stop-daemon >/dev/null; then
    start-stop-daemon --stop --quiet --oknodo --retry 30 \
      --pidfile $pidfile
  else
    _ignore_error killproc -p $pidfile $name
  fi
290 291 292 293 294 295 296 297 298 299 300 301 302
}

# Starts a daemon if it's not yet running
check_and_start() {
  local name="$1"

  if ! check $name; then
    start $name
  fi
}

# Starts the master role
start_master() {
303
  start ganeti-wconfd
304 305
  start ganeti-masterd
  start ganeti-rapi
306
  start ganeti-luxid
307 308 309 310
}

# Stops the master role
stop_master() {
311
  stop ganeti-luxid
312 313
  stop ganeti-rapi
  stop ganeti-masterd
314
  stop ganeti-wconfd
315 316
}

317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340
# Start all daemons
start_all() {
  for i in $(list_start_daemons); do
    local rc=0

    # Try to start daemon
    start $i || rc=$?

    if ! errmsg=$(check_exitcode $rc); then
      echo "$errmsg" >&2
      return 1
    fi
  done

  return 0
}

# Stop all daemons
stop_all() {
  for i in $(list_stop_daemons); do
    stop $i
  done
}

341 342 343 344 345 346 347 348 349 350 351 352 353
# SIGHUP a process to force re-opening its logfiles
rotate_logs() {
  if [[ "$#" -lt 1 ]]; then
    echo 'Missing daemon name.' >&2
    return 1
  fi

  local name="$1"; shift
  local pidfile=$(_daemon_pidfile $name)
  local daemonexec=$(_daemon_executable $name)

  if type -p start-stop-daemon >/dev/null; then
    start-stop-daemon --stop --signal HUP --quiet \
354
      --oknodo --pidfile $pidfile
355 356 357 358 359 360 361 362 363 364 365 366 367 368
  else
    _ignore_error killproc \
      -p $pidfile \
      $daemonexec -HUP
  fi
}

# SIGHUP all processes
rotate_all_logs() {
  for i in $(list_stop_daemons); do
    rotate_logs $i
  done
}

369 370 371 372 373
# Reloads the SSH keys
reload_ssh_keys() {
  @RPL_SSH_INITD_SCRIPT@ restart
}

374 375 376 377 378 379
# Read @SYSCONFDIR@/rc.d/init.d/functions if start-stop-daemon not available
if ! type -p start-stop-daemon >/dev/null && \
   [[ -f @SYSCONFDIR@/rc.d/init.d/functions ]]; then
  _ignore_error . @SYSCONFDIR@/rc.d/init.d/functions
fi

380 381 382 383 384 385 386
if [[ "$#" -lt 1 ]]; then
  echo "Usage: $0 <action>" >&2
  exit 1
fi

orig_action=$1; shift

387 388 389 390 391
if [[ "$orig_action" == *_* ]]; then
  echo "Command must not contain underscores" >&2
  exit 1
fi

392 393 394 395 396 397 398 399 400 401 402
# Replace all dashes (-) with underlines (_)
action=${orig_action//-/_}

# Is it a known function?
if ! declare -F "$action" >/dev/null 2>&1; then
  echo "Unknown command: $orig_action" >&2
  exit 1
fi

# Call handler function
$action "$@"